<?php

declare(strict_types=1);

namespace App\Domain\Shared\Domain\Contract;

interface QueryHandlerInterface
{
    /**
     * @template T of QueryInterface
     * @template R of ResponseInterface
     * @param T $query
     * @return R
     */
    public function handle(QueryInterface $query): ResponseInterface;
}
